<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>VehicleComponents &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../../_static/doctools.js?v=888ff710"></script>
        <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Simulator" href="../../../advanced_topics/20_simulator_advanced.html" />
    <link rel="prev" title="Spawner" href="spawner.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            openPASS
              <img src="../../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../50_scenario_simulation.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../20_components.html">Component View</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../20_components.html#components-in-depth">Components in Depth</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="algorithm_lateral.html">Algorithm_Lateral</a></li>
<li class="toctree-l4"><a class="reference internal" href="algorithm_longitudinal.html">Algorithm_Longitudinal</a></li>
<li class="toctree-l4"><a class="reference internal" href="driver.html">Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_regular_driving.html">Dynamics_RegularDriving</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_scenario.html">Dynamics_Scenario</a></li>
<li class="toctree-l4"><a class="reference internal" href="sensor_driver.html">Sensor_Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="spawner.html">Spawner</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">VehicleComponents</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../50_scenario_simulation.html">Simulator</a></li>
          <li class="breadcrumb-item"><a href="../20_components.html">Component View</a></li>
      <li class="breadcrumb-item active">VehicleComponents</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../../_sources/user_guide/sim_user_guide/components/vehicle.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="vehiclecomponents">
<span id="components-vehiclecomponents"></span><h1>VehicleComponents<a class="headerlink" href="#vehiclecomponents" title="Link to this heading"></a></h1>
<section id="aeb">
<span id="components-aeb"></span><h2>AEB<a class="headerlink" href="#aeb" title="Link to this heading"></a></h2>
<p>The Autonomous Emergency Braking system checks if a collision is likely to occur in the near future and, if necessary, brakes to avoid the collision.
In each timestep, the system evaluates all objects detected by a Sensor and calculates the time to collision (TTC) for this object based on the perceived movement of the object.
If, for any object, the TTC is lower than the threshold of the component, then the component gets activated. The system deactivates if the TTC is larger than 1,5 times the threshold of the component.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Attribute</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>CollisionDetectionLongitudinalBoundary</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Additional length added the vehicle boundary when checking for collision detection</p></td>
</tr>
<tr class="row-odd"><td><p>CollisionDetectionLateralBoundary</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Additional width added the vehicle boundary when checking for collision detection</p></td>
</tr>
<tr class="row-even"><td><p>TTC</p></td>
<td><p>Double</p></td>
<td><p>s</p></td>
<td><p>Time to collision which is used to trigger AEB</p></td>
</tr>
<tr class="row-odd"><td><p>Acceleration</p></td>
<td><p>Double</p></td>
<td><p>m/s²</p></td>
<td><p>Braking acceleration when activated</p></td>
</tr>
</tbody>
</table>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;ProfileGroup</span><span class="w"> </span><span class="na">Type=</span><span class="s">&quot;AEB&quot;</span><span class="nt">&gt;</span>
<span class="w">    </span><span class="nt">&lt;Profile</span><span class="w"> </span><span class="na">Type=</span><span class="s">&quot;AEB&quot;</span><span class="w"> </span><span class="na">Name=</span><span class="s">&quot;AEB1&quot;</span><span class="nt">&gt;</span>
<span class="w">        </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;CollisionDetectionLongitudinalBoundary&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;4.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;CollisionDetectionLateralBoundary&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;1.5&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;TTC&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;2.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;Acceleration&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;-2&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Profile&gt;</span>
<span class="w">    </span>...
<span class="nt">&lt;/ProfileGroup&gt;</span>
</pre></div>
</div>
</section>
<section id="dynamicstrajectoryfollower">
<span id="components-trajectoryfollower"></span><h2>DynamicsTrajectoryFollower<a class="headerlink" href="#dynamicstrajectoryfollower" title="Link to this heading"></a></h2>
<p>This module forces agents to drive according to a specific trajectory. The trajectory is defined in the scenario. This module is disabled by default and is activated if a trajectory from <a class="reference external" href="https://www.asam.net/standards/detail/openscenario/">OpenSCENARIO</a> is triggered.
It is always important that the trajectories matches the current scenery file, otherwise the Agent could be placed outside of valid lanes. If the agent gets placed on a invalid position, it will be deleted.</p>
<p>All attributes are required.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Attribute</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>AutomaticDeactivation</p></td>
<td><p>Bool</p></td>
<td><p>If true, the trajectory follower relinquishes control of the vehicle after the final instruction in the TrajectoryFile.
If false, it stops at the last point of the trajectory.</p></td>
</tr>
<tr class="row-odd"><td><p>EnforceTrajectory</p></td>
<td><p>Bool</p></td>
<td><p>If true, the trajectory follower overrides external input related to the vehicle’s travel.</p></td>
</tr>
</tbody>
</table>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;ProfileGroup</span><span class="w"> </span><span class="na">Type=</span><span class="s">&quot;DynamicsTrajectoryFollower&quot;</span><span class="nt">&gt;</span>
<span class="w">    </span><span class="nt">&lt;Profile</span><span class="w"> </span><span class="na">Name=</span><span class="s">&quot;BasicTrajectoryFollower&quot;</span><span class="nt">&gt;</span>
<span class="w">        </span><span class="nt">&lt;Bool</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;AutomaticDeactivation&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;true&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;Bool</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;EnforceTrajectory&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;true&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Profile&gt;</span>
<span class="nt">&lt;/ProfileGroup&gt;</span>
</pre></div>
</div>
</section>
<section id="fmu-wrapper">
<span id="components-fmuwrapper"></span><h2>FMU Wrapper<a class="headerlink" href="#fmu-wrapper" title="Link to this heading"></a></h2>
<p>The FMU Wrapper provides a connection to arbitrary FMUs (Functional Mock-up Unit).
An FMU has to be compatible with the FMI 1.0 or the FMI 2.0 specification (Functional Mock-up Interface) and has to be ABI (Application Binary Interface) compatible with the opSimulation binary.</p>
<p>Additional reading about FMI is provided by the FMI standard website at <a class="reference external" href="https://fmi-standard.org/">https://fmi-standard.org/</a>.
For interfacing the FMUs in openPASS, the Modelon FMI Library is used, which is recommended on the FMI standard website. See <a class="reference external" href="https://jmodelica.org/">https://jmodelica.org/</a>.</p>
<p><strong>FMU package format</strong></p>
<p>FMI defines a packaging format for FMUs.
The used container format is ZIP.
It basically contains - among other parts -  the compiled FMU code (as <code class="docutils literal notranslate"><span class="pre">*.dll</span></code> or <code class="docutils literal notranslate"><span class="pre">*.so</span></code>, depending on the platform) and the <code class="docutils literal notranslate"><span class="pre">modelDescription.xml</span></code>.
Latter provides meta-data about the FMU, i. e.
- Author information
- Model name, identifier and description
- Generation timestamp
- Name and datatype of model variables (inputs and outputs)</p>
<p><strong>Architectural overview</strong></p>
<p>The wrapper is instantiated as a component of an agent.
It reads the input variables for the FMU from the simulation and provides it the FMU and reads the output of the FMU and forwards it via signals to other agent components.</p>
<img alt="|op| FMU wrapper architectural overview" src="../../../_images/FmuWrapperOverview.svg" /><p><strong>Framework channels</strong></p>
<p>The wrapper can use input and output signals via <em>Channels</em> as every other agent component does.
Framework channels (signals) can provide data and can also be written to by the wrapper.
In addition, the wrapper is able to access the c AgentInterface and c WorldInterface methods.</p>
<p><strong>FMI variables</strong></p>
<p>Communication with the FMU happens via FMI variables (inputs and outputs).
The wrapper will read in available variables from <code class="docutils literal notranslate"><span class="pre">modelDescription.xml</span></code> in the FMU package.
These variables need to be mapped to variables and signals of openPASS in the VehicleComponentProfile.</p>
<p>FMI 1.0 supports these standard datatypes:
- bool
- integer
- real
- string</p>
<p>By using OSMP, three integer values can be used to support full osi messages</p>
<p><strong>Configuration</strong></p>
<p>Configuration of a particular FMU takes place in <code class="docutils literal notranslate"><span class="pre">ProfilesCatalog.xml</span></code>.
An example of a static system configuration can be found here “sim/contrib/examples/Configurations/StaticOSMPSensorDataToTrafficUpdateStepper”.</p>
<p>The following parameters are always required for the FmuWrapper. Depending on the FmuHandler additional parameters may be needed.</p>
<table class="tight-table docutils align-default" id="fmuwrapper-basic-configuration">
<thead>
<tr class="row-odd"><th class="head"><p>Key</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Default</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>FmuPath</p></td>
<td><p>string</p></td>
<td><p>-</p></td>
<td><p>Path to FMU file, either absolute or relative to the simulator’s configuration directory.</p></td>
</tr>
<tr class="row-odd"><td><p>Logging</p></td>
<td><p>bool</p></td>
<td><p>true</p></td>
<td><p>If set to true, FMU initialization and execution task are logged to a text file.</p></td>
</tr>
<tr class="row-even"><td><p>CsvOutput</p></td>
<td><p>bool</p></td>
<td><p>true</p></td>
<td><p>If set to true, FMI outputs are logged to a CSV file.</p></td>
</tr>
</tbody>
</table>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;ProfileGroup</span><span class="w"> </span><span class="na">Type=</span><span class="s">&quot;FMU1&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;Profile</span><span class="w"> </span><span class="na">Name=</span><span class="s">&quot;FMU&quot;</span><span class="nt">&gt;</span>
<span class="w">    </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;FmuPath&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;OSMPSDToTUS.fmu&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;Bool</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;Logging&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;true&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;Bool</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;CsvOutput&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;false&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;Input_OSMPSensorDataIn&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;SensorData&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;Input_OSMPSensorViewInConfig&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;SensorViewConfig&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;Output_OSMPTrafficUpdateOut&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;TrafficUpdate&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;Output_OSMPSensorViewInConfigRequest&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;SensorViewConfigRequest&quot;</span><span class="nt">/&gt;</span>
<span class="w"> </span><span class="nt">&lt;Bool</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;WriteJson_SensorData&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;false&quot;</span><span class="nt">/&gt;</span>
<span class="w"> </span><span class="nt">&lt;Bool</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;WriteJson_TrafficUpdate&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;false&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;/Profile&gt;</span>
<span class="nt">&lt;/ProfileGroup&gt;</span>
</pre></div>
</div>
<p>Upon instantiation of the FMU wrapper, it will extract the FMU ZIP file to a temporary directory.
Then the <code class="docutils literal notranslate"><span class="pre">modelDescription.xml</span></code> is parsed and the FMU is checked for compatibility.</p>
<p>If the parameter <code class="docutils literal notranslate"><span class="pre">CsvOutput</span></code> is set to <cite>true</cite>, a subfolder “FmuWrapper/Agent&lt;ID&gt;” will be created in the simulator’s “results” directory.
“&lt;ID&gt;” is replaced with the agent id.
FMI output data will be logged to a file inside this directory.
The filename consists of the FMU’s name and extension “csv”.
This output can then be used for visualization in a spreadsheet application or it may be processed in any other way.</p>
<p>Same goes for parameter <code class="docutils literal notranslate"><span class="pre">Logging</span></code> (having “log” as output file extension).</p>
<p><strong>Primitive Datatypes</strong></p>
<p>The FMU Wrapper allows to link Simulink models or any other FMU to <strong>openPASS</strong>.
It lets the user link any input variables of the FMU to values of the Agent in the simulation and any output values of the FMU to signals, that are forwarded to other <strong>openPASS</strong> components.
These mappings are defined with the following optional parameters.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Be careful with the size of integer data types when used in Matlab/Simulink. The FMU integer data type shall always be 32 bit or bigger, e.g. for IDs.</p>
</div>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Key</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>Parameter_<em>varName</em></p></td>
<td><p>any</p></td>
<td><p>Mapping of a fixed value (bool, integer, double, string) to an FMU input:</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">varName</span></code> references an FMI input variable.</p></li>
<li><p>The type of the parameter has to match the FMI variable type.</p></li>
</ul>
</td>
</tr>
<tr class="row-odd"><td><p>Parameter_AssignSpecial_<em>varName</em></p></td>
<td><p>any</p></td>
<td><p>Mapping of a specific value of the simulation to an FMU input, assigned only once at FMU initialization:</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">varName</span></code> references an FMI input variable.</p></li>
<li><p>The parameter is always of type string.</p></li>
<li><p>The value of this parameter has to be one of the types specified in the <a class="reference internal" href="#special-simulation-values">Special simulation values</a> table below,
which will also determine the required type of the FMI variable.</p></li>
</ul>
</td>
</tr>
<tr class="row-even"><td><p>Input_<em>varName</em></p></td>
<td><p>string</p></td>
<td><p>Mapping of a specific value of the simulation to an FMU input:</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">varName</span></code> references an FMI input variable.</p></li>
<li><p>The value of this parameter has to be one of the types specified in the <a class="reference internal" href="#input-simulation-values">Input simulation values</a> table below.</p></li>
</ul>
</td>
</tr>
<tr class="row-odd"><td><p>Output_<em>varName</em></p></td>
<td><p>string</p></td>
<td><p>Mapping of a FMU output to a specific field in a specific signal:</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">varName</span></code> references an FMI output variable.</p></li>
<li><p>The value of this parameter has to be one of the types specified in the <a class="reference internal" href="#output-simulation-signals">Output simulation signals</a> table below.</p></li>
</ul>
</td>
</tr>
</tbody>
</table>
<p>The allowed special simulation values are as follows:</p>
<table class="tight-table docutils align-default" id="special-simulation-values">
<thead>
<tr class="row-odd"><th class="head"><p>Type</p></th>
<th class="head"><p>FMU Variable Type</p></th>
<th class="head"><p>Calculation</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>RandomSeed</p></td>
<td><p>Integer</p></td>
<td><p>The random seed of the current simulation run.</p></td>
</tr>
<tr class="row-odd"><td><p>ConfigPath</p></td>
<td><p>String</p></td>
<td><p>Config directory supplied to opSimulation (or the corresponding default value)</p></td>
</tr>
<tr class="row-even"><td><p>OutputPath</p></td>
<td><p>String</p></td>
<td><p>An output path unique to this FmuWrapper instance.
The path will always refer to a directory below the simulator’s current result folder.
This directory is not necessarily created by the FmuWrapper, depending on the setting of
<cite>CsvOutput</cite> and <cite>Logging</cite> parameters (see <a class="reference internal" href="#fmuwrapper-basic-configuration">FmuWrapper basic configuration</a>).</p></td>
</tr>
<tr class="row-odd"><td><p>MaxSteering</p></td>
<td><p>Real</p></td>
<td><p>The <cite>max_steering</cite> property of an agent’s front axle as defined in OpenSCENARIO (catalog).</p></td>
</tr>
<tr class="row-even"><td><p>AxleRatio</p></td>
<td><p>Real</p></td>
<td><p>The axle ratio of the vehicle model.
Has to be defined in the properties of the Entity in the OpenSCENARIO catalog with the name
<code class="docutils literal notranslate"><span class="pre">AxleRatio</span></code> and the value has to be a valid floating point expression.</p></td>
</tr>
<tr class="row-odd"><td><p>SteeringRatio</p></td>
<td><p>Real</p></td>
<td><p>The steering ratio of the vehicle model.
Has to be defined in the properties of the Entity in the OpenSCENARIO catalog with the name
<code class="docutils literal notranslate"><span class="pre">SteeringRatio</span></code> and the value has to be a valid floating point expression.</p></td>
</tr>
<tr class="row-even"><td><p>NumberOfGears</p></td>
<td><p>Integer</p></td>
<td><p>The number of gears of the vehicle model.
Has to be defined in the properties of the Entity in the OpenSCENARIO catalog with the name
<code class="docutils literal notranslate"><span class="pre">NumberOfGears</span></code> and the value has to be a valid integer.</p></td>
</tr>
<tr class="row-odd"><td><p>GearRatio<em>N</em></p></td>
<td><p>Real</p></td>
<td><p>The ratio of the Nth gear.
Has to be defined in the properties of the Entity in the OpenSCENARIO catalog with the name
<code class="docutils literal notranslate"><span class="pre">GearRatioN</span></code> and the value has to be a valid floating point expression.
<em>N</em> is allowed to be in the range 1-9.</p></td>
</tr>
</tbody>
</table>
<p>The allowed inputs (simulation values) are as follows:</p>
<table class="tight-table docutils align-default" id="input-simulation-values">
<thead>
<tr class="row-odd"><th class="head"><p>Type</p></th>
<th class="head"><p>FMU Variable Type</p></th>
<th class="head"><p>Calculation</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>VelocityEgo</p></td>
<td><p>Real</p></td>
<td><p>Absolute velocity (length of the velocity vector) at reference point</p></td>
</tr>
<tr class="row-odd"><td><p>AccelerationEgo</p></td>
<td><p>Real</p></td>
<td><p>Longitudinal acceleration at reference point</p></td>
</tr>
<tr class="row-even"><td><p>CentripetalAccelerationEgo</p></td>
<td><p>Real</p></td>
<td><p>Centripetal acceleration at reference point</p></td>
</tr>
<tr class="row-odd"><td><p>SteeringWheelEgo</p></td>
<td><p>Real</p></td>
<td><p>Angle of the steering wheel (in radian)</p></td>
</tr>
<tr class="row-even"><td><p>AccelerationPedalPositionEgo</p></td>
<td><p>Real</p></td>
<td><p>Position of the acceleration pedal in the interval [0, 1]</p></td>
</tr>
<tr class="row-odd"><td><p>BrakePedalPositionEgo</p></td>
<td><p>Real</p></td>
<td><p>Position of the brake pedal in the interval [0, 1]</p></td>
</tr>
<tr class="row-even"><td><p>DistanceRefToFrontEdgeEgo</p></td>
<td><p>Real</p></td>
<td><p>Distance between the reference point and the front of the agent (static)</p></td>
</tr>
<tr class="row-odd"><td><p>PositionXEgo</p></td>
<td><p>Real</p></td>
<td><p>X position of the reference point</p></td>
</tr>
<tr class="row-even"><td><p>PositionYEgo</p></td>
<td><p>Real</p></td>
<td><p>Y position of the reference point</p></td>
</tr>
<tr class="row-odd"><td><p>YawEgo</p></td>
<td><p>Real</p></td>
<td><p>Yaw of the reference point</p></td>
</tr>
<tr class="row-even"><td><p>LaneEgo</p></td>
<td><p>Integer</p></td>
<td><p>Lane id of the front center on the route (0, if off route)</p></td>
</tr>
<tr class="row-odd"><td><p>PositionSEgo</p></td>
<td><p>Real</p></td>
<td><p>S position of the reference point on the route (0, if off route)</p></td>
</tr>
<tr class="row-even"><td><p>PositionTEgo</p></td>
<td><p>Real</p></td>
<td><p>T position of the reference point on the route (0, if off route)</p></td>
</tr>
<tr class="row-odd"><td><p>ExistenceFront</p></td>
<td><p>Boolean</p></td>
<td><p>true, if there is a object in front on the own lane (any range), false otherwise</p></td>
</tr>
<tr class="row-even"><td><p>PositionXFront</p></td>
<td><p>Real</p></td>
<td><p>X position of front object reference point (0, if no front object)</p></td>
</tr>
<tr class="row-odd"><td><p>PositionYFront</p></td>
<td><p>Real</p></td>
<td><p>Y position of front object reference point (0, if no front object)</p></td>
</tr>
<tr class="row-even"><td><p>YawFront</p></td>
<td><p>Real</p></td>
<td><p>Yaw of front object reference point (0, if no front object)</p></td>
</tr>
<tr class="row-odd"><td><p>PositionSFront</p></td>
<td><p>Real</p></td>
<td><p>S position of front object reference point on ego route (0, if no front object)</p></td>
</tr>
<tr class="row-even"><td><p>PositionTFront</p></td>
<td><p>Real</p></td>
<td><p>T position of front object reference point on ego route (0, if no front object)</p></td>
</tr>
<tr class="row-odd"><td><p>RelativeDistanceFront</p></td>
<td><p>Real</p></td>
<td><p>Net distance to front object along route (0, if no front object)</p></td>
</tr>
<tr class="row-even"><td><p>WidthFront</p></td>
<td><p>Real</p></td>
<td><p>Width of front object (0, if no front object)</p></td>
</tr>
<tr class="row-odd"><td><p>LengthFront</p></td>
<td><p>Real</p></td>
<td><p>Length of front object (0, if no front object)</p></td>
</tr>
<tr class="row-even"><td><p>DistanceRefToFrontEdgeFront</p></td>
<td><p>Real</p></td>
<td><p>Distance between the reference point and the front of the front object (0, if no front object)</p></td>
</tr>
<tr class="row-odd"><td><p>VelocityFront</p></td>
<td><p>Real</p></td>
<td><p>Absolute velocity of front object at reference point (0, if no front object)</p></td>
</tr>
<tr class="row-even"><td><p>LaneFront</p></td>
<td><p>Integer</p></td>
<td><p>Lane id of the reference point of the front object on the ego route (0, if no front object)</p></td>
</tr>
<tr class="row-odd"><td><p>ExistenceFrontFront</p></td>
<td><p>Boolean</p></td>
<td><p>true, if there are at least two objects in front on the own lane (any range), false otherwise</p></td>
</tr>
<tr class="row-even"><td><p>PositionXFrontFront</p></td>
<td><p>Real</p></td>
<td><p>X position of second front object reference point (0, if no second front object)</p></td>
</tr>
<tr class="row-odd"><td><p>PositionYFrontFront</p></td>
<td><p>Real</p></td>
<td><p>Y position of second front object reference point (0, if no second front object)</p></td>
</tr>
<tr class="row-even"><td><p>RelativeDistanceFrontFront</p></td>
<td><p>Real</p></td>
<td><p>Net distance to second front object reference point (0, if no second front object)</p></td>
</tr>
<tr class="row-odd"><td><p>VelocityFrontFront</p></td>
<td><p>Real</p></td>
<td><p>Absolute velocity of second front object reference point (0, if no second front object)</p></td>
</tr>
<tr class="row-even"><td><p>LaneFrontFront</p></td>
<td><p>Integer</p></td>
<td><p>Lane id of the reference point of second front object reference point (0, if no second front object)</p></td>
</tr>
<tr class="row-odd"><td><p>LaneCountLeft</p></td>
<td><p>Integer</p></td>
<td><p>Number of lanes to the left of front center of type Driving, Exit, Entry, OnRamp or OffRamp</p></td>
</tr>
<tr class="row-even"><td><p>LaneCountRight</p></td>
<td><p>Integer</p></td>
<td><p>Number of lanes to the right of front center of type Driving, Exit, Entry, OnRamp or OffRamp</p></td>
</tr>
<tr class="row-odd"><td><p>SpeedLimit_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Speed limit in effect in distance <em>X</em> meters from front center (999, if no speed limit)</p></td>
</tr>
<tr class="row-even"><td><p>RoadCurvature_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Road curvature in distance <em>X</em> meters from front center</p></td>
</tr>
</tbody>
</table>
<ul class="simple">
<li><p><strong>reference point</strong>: Center of the rear axle</p></li>
<li><p><strong>front center</strong>: Center of the front of the bounding box of the object</p></li>
</ul>
<p>If the FmuWrapper is linked to at least one sensor with InputId “Camera”, the following additional inputs are available.
The objects seen by this sensor(s) are sorted by distance from the agent and accessed by indices starting from 0.
For each object the values listed in the following table are available where <em>X</em> is the index of the object (between 0 and 9).
If there are less objects than <em>X</em>, a default value is set (-1 for the Id, 0 for the other values).
Only the list of objects is taken from the sensor.
The values are then calculated by the FmuWrapper (not from the SensorData).</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Type</p></th>
<th class="head"><p>FMU Variable Type</p></th>
<th class="head"><p>Calculation</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>SensorFusionObjectId_<em>X</em></p></td>
<td><p>Integer</p></td>
<td><p>Id of the object</p></td>
</tr>
<tr class="row-odd"><td><p>SensorFusionNumberOfDetectingSensors_<em>X</em></p></td>
<td><p>Integer</p></td>
<td><p>Number of sensors detecting the object</p></td>
</tr>
<tr class="row-even"><td><p>SensorFusionRelativeS_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Distance between reference points along route (NaN, if object not on route)</p></td>
</tr>
<tr class="row-odd"><td><p>SensorFusionRelativeNetS_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Net distance along route (NaN, if object not on route)</p></td>
</tr>
<tr class="row-even"><td><p>SensorFusionRelativeT_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Lateral obstruction for front center (NaN, if object not on route) (see <a class="reference internal" href="../../../advanced_topics/simulator/world_osi.html#world-getobstruction"><span class="std std-ref">GetObstruction</span></a>)</p></td>
</tr>
<tr class="row-odd"><td><p>SensorFusionRelativeX_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Relative distance between reference points in x in world coordinates</p></td>
</tr>
<tr class="row-even"><td><p>SensorFusionRelativeY_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Relative distance between reference points in y in world coordinates</p></td>
</tr>
<tr class="row-odd"><td><p>SensorFusionRelativeNetLeft_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Lateral obstruction for leftmost point (NaN, if object not on route)</p></td>
</tr>
<tr class="row-even"><td><p>SensorFusionRelativeNetRight_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Lateral obstruction for rightmost point (NaN, if object not on route)</p></td>
</tr>
<tr class="row-odd"><td><p>SensorFusionRelativeNetX_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Net distance between bounding boxes in x in world coordinates</p></td>
</tr>
<tr class="row-even"><td><p>SensorFusionRelativeNetY_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Net distance between bounding boxes in y in world coordinates</p></td>
</tr>
<tr class="row-odd"><td><p>SensorFusionLane_<em>X</em></p></td>
<td><p>Integer</p></td>
<td><p>Lane of front center</p></td>
</tr>
<tr class="row-even"><td><p>SensorFusionVelocity_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Absolute velocity at reference point</p></td>
</tr>
<tr class="row-odd"><td><p>SensorFusionVelocityX_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Velocity in x at reference point in world coordinates</p></td>
</tr>
<tr class="row-even"><td><p>SensorFusionVelocityY_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Velocity in y at reference point in world coordinates</p></td>
</tr>
<tr class="row-odd"><td><p>SensorFusionYaw_<em>X</em></p></td>
<td><p>Real</p></td>
<td><p>Yaw in world coordinates</p></td>
</tr>
</tbody>
</table>
<p>The FMU wrapper can output one or more of these signals:
AccelerationSignal, LongitudinalSignal, SteeringSignal and DynamicsSignal</p>
<p>The name of the signal field has to be specified after the signal name.
This means the output type is one of the following:</p>
<table class="tight-table docutils align-default" id="output-simulation-signals">
<thead>
<tr class="row-odd"><th class="head"><p>Type</p></th>
<th class="head"><p>FMU Variable Type</p></th>
<th class="head"><p>Enum Values</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>ComponentState</p></td>
<td><p>Enum</p></td>
<td><p>Undefined, Disabled, Armed, Acting</p></td>
</tr>
<tr class="row-odd"><td><p>AccelerationSignal_Acceleration</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>LongitudinalSignal_AccPedalPos</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>LongitudinalSignal_BrakePedalPos</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>LongitudinalSignal_Gear</p></td>
<td><p>Int</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>SteeringSignal_SteeringWheelAngle</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>DynamicsSignal_Acceleration</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>DynamicsSignal_Velocity</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>DynamicsSignal_PositionX</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>DynamicsSignal_PositionY</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>DynamicsSignal_Yaw</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>DynamicsSignal_YawRate</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>DynamicsSignal_YawAcceleration</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>DynamicsSignal_SteeringWheelAngle</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>DynamicsSignal_CentripetalAcceleration</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>DynamicsSignal_TravelDistance</p></td>
<td><p>Real</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>CompCtrlSignal_MovementDomain</p></td>
<td><p>Enum</p></td>
<td><p>Undefined, Lateral, Longitudinal, Both</p></td>
</tr>
<tr class="row-odd"><td><p>CompCtrlSignal_WarningActivity</p></td>
<td><p>Bool</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>CompCtrlSignal_WarningLevel</p></td>
<td><p>Enum</p></td>
<td><p>INFO, WARNING</p></td>
</tr>
<tr class="row-odd"><td><p>CompCtrlSignal_WarningType</p></td>
<td><p>Enum</p></td>
<td><p>OPTIC, ACOUSTIC, HAPTIC</p></td>
</tr>
<tr class="row-even"><td><p>CompCtrlSignal_WarningIntensity</p></td>
<td><p>Enum</p></td>
<td><p>LOW, MEDIUM, HIGH</p></td>
</tr>
<tr class="row-odd"><td><p>CompCtrlSignal_WarningDirection</p></td>
<td><p>Enum</p></td>
<td></td>
</tr>
</tbody>
</table>
<p>If one of these fields of a signal (except ComponentState) is mapped to an FMU variable, all fields of this signal have to be mapped.
If the ComponentState is mapped to a FMU variable, it is used for all signals, otherwise it defaults to Acting.</p>
<p><strong>OSI Data</strong></p>
<p>OSMP (OsiSensorModelPackaging) is a package layer specification for the Open Simulation Interface (OSI).
It allows to pass input to the FMU as OSI messages as well as receive output as OSI message.
For more information on OSMP see <a class="reference external" href="https://github.com/OpenSimulationInterface/osi-sensor-model-packaging">https://github.com/OpenSimulationInterface/osi-sensor-model-packaging</a>.</p>
<p>The FmuHandler has the following additional (optional) parameters:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Key</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>Init_<em>var_name</em></p></td>
<td><p>string</p></td>
<td><p><em>var_name</em> references an FMU variable (as defined in FMU’s modelDescription.xml) to which a specific OSI message is sent during initialization  Allowed values: <cite>GroundTruth</cite></p></td>
</tr>
<tr class="row-odd"><td><p>Input_<em>var_name</em></p></td>
<td><p>string</p></td>
<td><p><em>var_name</em> references an FMU variable (as defined in FMU’s modelDescription.xml) to which a specific OSI message is sent  Allowed values: <cite>SensorView</cite>, <cite>SensorViewConfig</cite>, <cite>SensorData</cite>, <cite>TrafficCommand</cite></p></td>
</tr>
<tr class="row-even"><td><p>Output_<em>var_name</em></p></td>
<td><p>string</p></td>
<td><p><em>var_name</em> references an FMU variable (as defined in FMU’s modelDescription.xml) from which a specific OSI message is received  Allowed values: <cite>SensorViewConfigRequest</cite>, <cite>SensorData</cite>, <cite>TrafficUpdate</cite></p></td>
</tr>
<tr class="row-odd"><td><p>Parameter_<em>var_name</em></p></td>
<td><p>any</p></td>
<td><p>The value of the parameter is assigned to the FMU variable <em>var_name</em></p></td>
</tr>
<tr class="row-even"><td><p>Parameter_<em>transformation</em>[<em>mapping</em> ]_<em>name</em></p></td>
<td><p>string/string/any*</p></td>
<td><p>Same as Parameter_<em>name</em> but with an preceding <em>transformation</em> according to a <em>mapping</em>. <br> Currently, only mappings between the same types are supported. <br> *;When using <cite>TransformList</cite> as <em>transformation</em>, the type of the data is expected to be a string and the string must be a comma separated list of values. <br>  <br> Allowed values: <br> <em>transformation</em>: <cite>Transform</cite>, <cite>TransformList</cite> <br> <em>mapping</em>: <cite>ScenarioName&gt;Id</cite> <br>  <br> Example: <cite>Parameter_TransformList[ScenarioName&gt;Id]_*name*</cite></p></td>
</tr>
<tr class="row-odd"><td><p>WriteJson_<em>var_name</em></p></td>
<td><p>bool</p></td>
<td><p>If true the osi message specified by <em>var_name</em> is written to a json file</p></td>
</tr>
<tr class="row-even"><td><p>WriteTrace_<em>var_name</em></p></td>
<td><p>bool</p></td>
<td><p>If true the osi message specified by <em>var_name</em> is written to the trace file</p></td>
</tr>
<tr class="row-odd"><td><p>EnforceDoubleBuffering</p></td>
<td><p>bool</p></td>
<td><p>If true the wrapper will throw an error if FMU doesn’t use double buffering. Defaults to false.</p></td>
</tr>
</tbody>
</table>
<p>The type of OSI messages the FmuHandler sends and receives is defined by its parameters. Only messages for which an FMU variable is given in the configuration are sent/received.
An additional parameter defines whether the message should be logged as JSON file for every agent and every timestep (see table above).</p>
<p>Currently these messages are supported:</p>
<ul class="simple">
<li><p>SensorView: SensorView generated from the GroundTruth with this agent is host vehicle.</p></li>
<li><p>SensorViewConfig, SensorViewConfigRequest: Configuration of a sensor according to OSMP.</p></li>
<li><p>TrafficCommand: Trajectory from <a class="reference external" href="https://www.asam.net/standards/detail/openscenario/">OpenSCENARIO</a>, that will be converted into a TrafficCommand.</p></li>
<li><p>SensorData: Output of a sensor. Can be input and/or output of an FMU. Received SensorData is forwarded to other components as SensorDataSignal.</p></li>
<li><p>TrafficUpdate: Will be converted to a DynamicsSignal, AccelerationSignal, SteeringSignal or LongitudinalSignal. If the update is empty, the signal will have ComponentState::Disabled. If it is only partially filled, the missing values for the DynamicsSignal will be set to the current state.</p></li>
<li><p>GroundTruth: Will be used as groundtruth information for everything that exists in the simulation world.</p></li>
</ul>
<p><strong>FmuVariables</strong></p>
<p>FmuVariables can have different variability and causality.</p>
<ul class="simple">
<li><p>There are the following causalities: Input, Output, Parameter and CalculatedParameter</p></li>
<li><p>Input or outputs can have the variability constant, fixed, discrete or continuous</p></li>
<li><p>Parameter or CalculatedParameter can have the variability constant, fixed or tunable</p></li>
</ul>
<p>In openPASS we have the initialization phase, which is only called once. In that phase first readValues is called.
Then parameter values are synchronized between different config files. The following priority is used for the synchronization:</p>
<p>modelDescription &lt; systemConfig &lt; SSP config.</p>
<p>Afterwards still in the initialization phase writeValues is called.
During the whole simulation in openPASS all the trigger functions are called each time step.
For the FMU component we call WriteValues before trigger and readValues afterwards.
For the first two time steps we have the following calls for read- and writeValues:</p>
<blockquote>
<div><ol class="arabic simple">
<li><p>ReadValues (Init)</p></li>
<li><p>WriteValues (Init)</p></li>
<li><p>WriteValues</p></li>
<li><p>Trigger</p></li>
<li><p>ReadValues</p></li>
<li><p>WriteValues</p></li>
<li><p>Trigger</p></li>
<li><p>ReadValues</p></li>
</ol>
</div></blockquote>
<p>Depending on them, FmuVariables are written/read to/from the FMU on different occasions, which is shown in the following table.</p>
<table class="docutils align-default" id="id1">
<caption><span class="caption-text">Write- and ReadValues depending on variability and causality</span><a class="headerlink" href="#id1" title="Link to this table"></a></caption>
<colgroup>
<col style="width: 20.0%" />
<col style="width: 20.0%" />
<col style="width: 20.0%" />
<col style="width: 20.0%" />
<col style="width: 20.0%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head stub"></th>
<th class="head"><p>ReadValues - Init</p></th>
<th class="head"><p>WriteValues - Init</p></th>
<th class="head"><p>WriteValues - Trigger</p></th>
<th class="head"><p>ReadValues - Trigger</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><th class="stub"><p>Input - fixed</p></th>
<td><p>x</p></td>
<td><p>x</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><th class="stub"><p>Input - discrete or continuous</p></th>
<td><p>x</p></td>
<td><p>x</p></td>
<td><p>x</p></td>
<td></td>
</tr>
<tr class="row-even"><th class="stub"><p>Output - fixed</p></th>
<td><p>x</p></td>
<td></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><th class="stub"><p>Output - discrete or continuous</p></th>
<td><p>x</p></td>
<td></td>
<td></td>
<td><p>x</p></td>
</tr>
<tr class="row-even"><th class="stub"><p>Parameter - fixed</p></th>
<td><p>x</p></td>
<td><p>x</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><th class="stub"><p>Parameter - tunable</p></th>
<td><p>x</p></td>
<td><p>x</p></td>
<td><p>x</p></td>
<td></td>
</tr>
<tr class="row-even"><th class="stub"><p>CalculatedParameter - fixed</p></th>
<td><p>x</p></td>
<td></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><th class="stub"><p>CalculatedParameter - tunable</p></th>
<td><p>x</p></td>
<td></td>
<td></td>
<td><p>x</p></td>
</tr>
</tbody>
</table>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>For alle kinds of Input, Output, Parameter and CalculatedParameter there exists the variablity “constant”.
All constant values are only read into openPASS once at the initialization phase.
Never will these values be written onto the FMU.</p>
</div>
</section>
<section id="sensorgeometric2d">
<span id="components-geometric2d"></span><h2>SensorGeometric2D<a class="headerlink" href="#sensorgeometric2d" title="Link to this heading"></a></h2>
<p>This sensor is selected, when a sensor is parameterized as ProfileGroup “Geometric2D”.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Parameter</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>DetectionRange</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Detection range</p></td>
</tr>
<tr class="row-odd"><td><p>EnableVisualObstruction</p></td>
<td><p>Bool</p></td>
<td></td>
<td><p>Activates 2D sensor obstruction calculation</p></td>
</tr>
<tr class="row-even"><td><p>FailureProbability</p></td>
<td><p>Double</p></td>
<td></td>
<td><p>Probability object is not detected although it is visible</p></td>
</tr>
<tr class="row-odd"><td><p>Latency</p></td>
<td><p>Double</p></td>
<td><p>s</p></td>
<td><p>Delay the sensor output</p></td>
</tr>
<tr class="row-even"><td><p>DetectionDelayTime</p></td>
<td><p>Double</p></td>
<td><p>s</p></td>
<td><p>Time an object needs to be in detection range before it is detected (optional)</p></td>
</tr>
<tr class="row-odd"><td><p>MaxDropOutTime</p></td>
<td><p>Double</p></td>
<td><p>s</p></td>
<td><p>Time after which delay for undetected object starts anew (optional)</p></td>
</tr>
<tr class="row-even"><td><p>OpeningAngleH</p></td>
<td><p>Double</p></td>
<td><p>rad</p></td>
<td><p>Horizontal opening angle</p></td>
</tr>
<tr class="row-odd"><td><p>RequiredPercentageOfVisibleArea</p></td>
<td><p>Double</p></td>
<td></td>
<td><p>Required percentage of an object within the sensor cone to trigger a detection</p></td>
</tr>
</tbody>
</table>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;ProfileGroup</span><span class="w"> </span><span class="na">Type=</span><span class="s">&quot;Geometric2D&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;Profile</span><span class="w"> </span><span class="na">Name=</span><span class="s">&quot;Standard&quot;</span><span class="nt">&gt;</span>
<span class="w">    </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;DetectionRange&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;300&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;Bool</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;EnableVisualObstruction&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;false&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;FailureProbability&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;0&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;NormalDistribution</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;Latency&quot;</span><span class="w"> </span><span class="na">Max=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">Mean=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">Min=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">SD=</span><span class="s">&quot;0.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;OpeningAngleH&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;0.35&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;RequiredPercentageOfVisibleArea&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;0.001&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;DetectionDelayTime&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;0&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;MaxDropOutTime&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;0&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;/Profile&gt;</span>
<span class="nt">&lt;/ProfileGroup&gt;</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Sensors also need a mounting position, defined w.r.t. the coordinate system of the vehicle (center of rear axis).
See also <a class="reference internal" href="../../configs/profilescatalog.html#profilescatalog-systemprofiles"><span class="std std-ref">SystemProfiles</span></a>.</p>
</div>
</section>
<section id="receivercar2x">
<h2>ReceiverCar2X<a class="headerlink" href="#receivercar2x" title="Link to this heading"></a></h2>
<p>This type is selected, when a sensor is parameterized as ProfileGroup “ReceiverCar2X”.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Parameter</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>FailureProbability</p></td>
<td><p>Double</p></td>
<td></td>
<td><p>Probability object is not detected although it is visible</p></td>
</tr>
<tr class="row-odd"><td><p>Latency</p></td>
<td><p>Double</p></td>
<td><p>s</p></td>
<td><p>Sensor latency</p></td>
</tr>
<tr class="row-even"><td><p>Sensitivity</p></td>
<td><p>Double</p></td>
<td><p>W/m²</p></td>
<td><p>Sensitivity of the sensor</p></td>
</tr>
</tbody>
</table>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;ProfileGroup</span><span class="w"> </span><span class="na">Type=</span><span class="s">&quot;ReceiverCar2X&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;Profile</span><span class="w"> </span><span class="na">Name=</span><span class="s">&quot;Standard&quot;</span><span class="nt">&gt;</span>
<span class="w">    </span><span class="nt">&lt;NormalDistribution</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;Latency&quot;</span><span class="w"> </span><span class="na">Mean=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">SD=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">Min=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">Max=</span><span class="s">&quot;0.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;FailureProbability&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;0&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;Sensitivity&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;1e-5&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;/Profile&gt;</span>
<span class="nt">&lt;/ProfileGroup&gt;</span>
</pre></div>
</div>
<p>The moving object is detected if the received SignalStrength is greater than the Sensitivity of the ReceiverCar2X .</p>
<p>The received SignalStrength is calculated by <img class="math" src="../../../_images/math/58936aa7043ecf62ec13166d1c340a6d7369c8fc.png" alt="ss_{\text{received}} = \frac {ss_{\text{sender}}} {4 \cdot pi \cdot d \cdot d}"/>, where the symbols meanings are:</p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Symbol</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/9d60d7b2311a5ab7cdaddaa12d7afcea0d61e610.png" alt="ss_{\text{received}}"/></p></td>
<td><p>Received strength of the signal [1/m²]</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../../_images/math/b4e3a410356817edeee8a7f41f7a577e2c269c48.png" alt="ss_{\text{sender}}"/></p></td>
<td><p>Sent strength of the signal [1/m²]</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../../_images/math/badad346f6fbe2e237af99bfbd9a93a4da53a3da.png" alt="d"/></p></td>
<td><p>Distance between the receiver agent and sender [m]</p></td>
</tr>
</tbody>
</table>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Sensors also need a mounting position, defined w.r.t. the coordinate system of the vehicle (center of rear axis).
See also <a class="reference internal" href="../../configs/profilescatalog.html#profilescatalog-systemprofiles"><span class="std std-ref">SystemProfiles</span></a>.</p>
</div>
</section>
<section id="ssp">
<h2>SSP<a class="headerlink" href="#ssp" title="Link to this heading"></a></h2>
<p>A SSP can be added as vehicle component. It’s a blackbox of one or multiple FMUs.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Parameter</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>SspPath</p></td>
<td><p>String</p></td>
<td><p>path</p></td>
<td><p>config relative path to ssp archive</p></td>
</tr>
</tbody>
</table>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;ProfileGroup</span><span class="w"> </span><span class="na">Type=</span><span class="s">&quot;SSP1&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;Profile</span><span class="w"> </span><span class="na">Name=</span><span class="s">&quot;SSP&quot;</span><span class="nt">&gt;</span>
<span class="w">          </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;SspPath&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;ConnectionTest.ssp&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;/Profile&gt;</span>
<span class="nt">&lt;/ProfileGroup&gt;</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>To add the ssp component to a system profile do the following:
See also <a class="reference internal" href="../../configs/profilescatalog.html#profilescatalog-systemprofiles"><span class="std std-ref">SystemProfiles</span></a>.</p>
</div>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">      </span><span class="nt">&lt;SystemProfile</span><span class="w"> </span><span class="na">Name=</span><span class="s">&quot;EgoVehicle&quot;</span><span class="w"> </span><span class="na">Probability=</span><span class="s">&quot;1.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/SystemProfiles&gt;</span>
</pre></div>
</div>
</section>
<section id="vehicledynamics">
<h2>VehicleDynamics<a class="headerlink" href="#vehicledynamics" title="Link to this heading"></a></h2>
<p>Components of this group can be used to model the vehicle dynamics. The vehicle dynamics model has a modular design. If necessary, the individual components can be replaced by the user with their own models. The vehicle dynamics model consists of six components listed below:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Component</p></th>
<th class="head"><p>Short Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><a class="reference internal" href="#components-steeringsystem"><span class="std std-ref">ActionSteeringSystem</span></a></p></td>
<td><p>The steering model transfers the driver’s input into the vehicle’s wheel angle</p></td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="#components-powertrain"><span class="std std-ref">ActionPowertrain</span></a></p></td>
<td><p>The powertrain model converts the accelerator pedal position into wheel drive torques, under consideration of the selected gear</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="#components-brakesystem"><span class="std std-ref">ActionBrakeSystem</span></a></p></td>
<td><p>The brake model converts the brake pedal position into wheel brake torques</p></td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="#components-tiremodel"><span class="std std-ref">DynamicsTireModel</span></a></p></td>
<td><p>The tire model converts the predetermined drive and braking torques of the tires into tire longitudinal and lateral forces, under consideration of the wheel angles</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="#components-motionmodel"><span class="std std-ref">DynamicsMotionModel</span></a></p></td>
<td><p>The motion model calculates the translational and rotational vehicle movement with the calculated tire forces</p></td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="#components-chassismodel"><span class="std std-ref">DynamicsChassis</span></a></p></td>
<td><p>The chassis model determines the dynamic wheel loads via the vehicle’s longitudinal and lateral acceleration</p></td>
</tr>
</tbody>
</table>
<p>The following figure gives an overview of the driving dynamics components and their signals:</p>
<img alt="|op| Vehicle dynamics overview" src="../../../_images/VehicleDynamicsOverview.svg" /><section id="actionsteeringsystem">
<span id="components-steeringsystem"></span><h3>ActionSteeringSystem<a class="headerlink" href="#actionsteeringsystem" title="Link to this heading"></a></h3>
<p>The steering model obtains the “SteeringRatio” property from the <a class="reference internal" href="../../configs/scenario.html#scenario-vehiclemodels"><span class="std std-ref">VehicleCatalog</span></a> and uses it to calculate the steering angle of the front wheels.
Both wheels are turned at the same angle. The following parameter can be used to set a static toe and the steering elasticity:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Attribute</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>StaticToe</p></td>
<td><p>VectorDouble</p></td>
<td><p>rad</p></td>
<td><p>Static toe of the wheels (A positive value corresponds to a toe-in; one static toe per axis)</p></td>
</tr>
<tr class="row-odd"><td><p>Elasticity</p></td>
<td><p>VectorDouble</p></td>
<td><p>rad/Nm</p></td>
<td><p>Steering Elasticity (one elasticity per axis)</p></td>
</tr>
<tr class="row-even"><td><p>Caster</p></td>
<td><p>VectorDouble</p></td>
<td><p>m</p></td>
<td><p>Overall Caster of steering system</p></td>
</tr>
</tbody>
</table>
</section>
<section id="actionpowertrain">
<span id="components-powertrain"></span><h3>ActionPowertrain<a class="headerlink" href="#actionpowertrain" title="Link to this heading"></a></h3>
<p>The powertrain model contains an engine model and a gear model. The type of the powertrain can be set using the following parameters:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Attribute</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>TypeDrivetrain</p></td>
<td><p>String</p></td>
<td></td>
<td><p>Type of drivetrain; A selection can be made between front-wheel drive (FWD), rear-wheel drive (RWD) and all-wheel drive (AWD)</p></td>
</tr>
<tr class="row-odd"><td><p>FrontRatioAWD</p></td>
<td><p>Double</p></td>
<td></td>
<td><p>Distribution of the drive torque to the front axle in the case of all-wheel drive (AWD); Range 0-1</p></td>
</tr>
</tbody>
</table>
<p>The wheel speed is converted into an engine speed [Hz] according to the axle ratio and the transmission ratio of the selected gear.
The axle ratio and gear ratios are obtained from the <a class="reference internal" href="../../configs/scenario.html#scenario-vehiclemodels"><span class="std std-ref">VehicleCatalog</span></a> (“AxleRatio” &amp; “GearRatio”). The average value of the powered wheels is used for the determination of the engine speed.</p>
<div class="math">
<p><img src="../../../_images/math/340d7e571b3feafaa7e510b6c7d1328b1f4c64ad.png" alt="\omega_{engine} = \omega_{wheels,avg} \cdot  i_{axle} \cdot i_{gear,selected}"/></p>
</div><p>The maximum possible engine torque [Nm] is limited by the engine power [W] or the maximum engine torque [Nm].
The engine power and the maximum engine torque are obtained from the <a class="reference internal" href="../../configs/scenario.html#scenario-vehiclemodels"><span class="std std-ref">VehicleCatalog</span></a> (“MaximumEnginePower” &amp; “MaximumEngineTorque”).</p>
<div class="math">
<p><img src="../../../_images/math/bb9c6cf90a7cce5208d424db5de2b83f0ef1fddb.png" alt="M_{engine,max,current} = \begin{cases}
 \frac{P_{engine,max}}{\omega_{engine}}     &amp; \text{ if } \frac{P_{engine,max}}{\omega_{engine}} &lt; M_{engine,max} \\
 M_{engine,max}  &amp; \text{ if } \frac{P_{engine,max}}{\omega_{engine}} &gt;= M_{engine,max}
     \end{cases}"/></p>
</div><p>When 98% of the maximum speed of the motor is reached (“MaximumEngineSpeed” in the <a class="reference internal" href="../../configs/scenario.html#scenario-vehiclemodels"><span class="std std-ref">VehicleCatalog</span></a>), the engine torque is linearly reduced to 0.</p>
<p>The maximum engine torque is scaled via the accelerator pedal position (input). This value is calculated back to the total wheel drive torque via the gear ratio.</p>
<div class="math">
<p><img src="../../../_images/math/1f81befb8ab4e6d3af9e6e11361477a156ea9836.png" alt="M_{wheels,current} = M_{engine,max,current} \cdot  position_{accelerator pedal} \cdot  i_{axle} \cdot  i_{gear,selected}"/></p>
</div><p>The wheel total drive torque is evenly distributed to the wheels of an axle according to the definition of the drive type.
With all-wheel drive, the entire wheel drive torque is distributed statically over the defined ratio.</p>
</section>
<section id="actionbrakesystem">
<span id="components-brakesystem"></span><h3>ActionBrakeSystem<a class="headerlink" href="#actionbrakesystem" title="Link to this heading"></a></h3>
<p>The brake model is a linearized model. The brake pedal position is used as input. As output, the model returns the braking torques of the wheels as a vector.
The model considers a response time [ms] and linear factors [m/s³] for the increase and decrease of the braking force.The distribution of braking force between the front and rear axles can be defined statically.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Attribute</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>FrontAxlePercentage</p></td>
<td><p>Double</p></td>
<td></td>
<td><p>Distribution of the brake torque to the front axle in the case of all-wheel drive (AWD); Range 0-1</p></td>
</tr>
<tr class="row-odd"><td><p>BrakeDecelerationInclineRate</p></td>
<td><p>Double</p></td>
<td><p>m/s³</p></td>
<td><p>Linear Rate of braking force increase</p></td>
</tr>
<tr class="row-even"><td><p>BrakeDecelerationDeclineRate</p></td>
<td><p>Double</p></td>
<td><p>m/s³</p></td>
<td><p>Linear Rate of braking force decrease</p></td>
</tr>
<tr class="row-odd"><td><p>BrakeResponseTimeMs</p></td>
<td><p>Double</p></td>
<td><p>ms</p></td>
<td><p>Brake response time</p></td>
</tr>
</tbody>
</table>
<p>The maximum braking force of the system is determined from the maximum possible deceleration and the mass of the vehicle and is scaled by the brake pedal position (Input).
The maximum possible deceleration and the vehicle mass are obtained from the <a class="reference internal" href="../../configs/scenario.html#scenario-vehiclemodels"><span class="std std-ref">VehicleCatalog</span></a> (“maxDeceleration” &amp; “mass”).</p>
<div class="math">
<p><img src="../../../_images/math/bc08e6aac48aefa03313665a4a532f6a9c5ecd63.png" alt="F_{brake,max} = a_{deceleration,max} \cdot m_{vehicle} \cdot  position_{brake pedal}"/></p>
</div><p>When the brake is applied, a deceleration is calculated after the response time has elapsed. Then the braking force is built up linearly until the maximum or requested braking force has been reached.</p>
<div class="math">
<p><img src="../../../_images/math/f1aece6474c2a5f6a6db0e37b59055fb90810d92.png" alt="F_{brake,current} = rate_{incline} \cdot (t_{brake} -  t_{response})"/></p>
</div><p>When the brake is released, the braking force is dissipated with the decline rate until it has dropped to zero. After that, the response time builds up again.
The braking force is divided among the axles according to the parameter “FrontAxlePercentage”. Another input allows you to request a prefill that reduces the response time without braking</p>
</section>
<section id="dynamicschassis">
<span id="components-chassismodel"></span><h3>DynamicsChassis<a class="headerlink" href="#dynamicschassis" title="Link to this heading"></a></h3>
<p>The chassis model determines the vertical forces of the four wheels from the longitudinal and lateral acceleration of the vehicle. Constant spring and damper rates are taken into account, which can be defined by the following parameters per axis:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Attribute</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>SpringCoefficient</p></td>
<td><p>VectorDouble</p></td>
<td><p>N/m</p></td>
<td><p>Constant spring coefficient for each axis</p></td>
</tr>
<tr class="row-odd"><td><p>DamperCoefficient</p></td>
<td><p>VectorDouble</p></td>
<td><p>Ns/m</p></td>
<td><p>Constant damper coefficient for each axis</p></td>
</tr>
</tbody>
</table>
</section>
<section id="dynamicstiremodel">
<span id="components-tiremodel"></span><h3>DynamicsTireModel<a class="headerlink" href="#dynamicstiremodel" title="Link to this heading"></a></h3>
<p>The tire model is freely configurable and includes a degressive behaviour. The tire forces are modeled according to Rill using the TMEasy model. The following parameters can be set for the tire model per axis :</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Attribute</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>MuTireMaxXFRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Normalized scaling factor for maximum longitudinal force at reference vertical force</p></td>
</tr>
<tr class="row-odd"><td><p>MuTireMaxX2FRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Normalized scaling factor for maximum longitudinal force at double reference vertical force</p></td>
</tr>
<tr class="row-even"><td><p>MuTireSlideXFRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Normalized scaling factor for sliding longitudinal force at reference vertical force</p></td>
</tr>
<tr class="row-odd"><td><p>MuTireSlideX2FRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Normalized scaling factor for sliding longitudinal force at double reference vertical force</p></td>
</tr>
<tr class="row-even"><td><p>SlipTireMaxXFRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Longitudinal slip at maximum longitudinal force at reference vertical force</p></td>
</tr>
<tr class="row-odd"><td><p>SlipTireMaxX2FRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Longitudinal slip at maximum longitudinal force at double reference vertical force</p></td>
</tr>
<tr class="row-even"><td><p>SlipTireSlideXFRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Longitudinal slip at sliding longitudinal force at reference vertical force</p></td>
</tr>
<tr class="row-odd"><td><p>SlipTireSlideX2FRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Longitudinal slip at sliding longitudinal force at double reference vertical force</p></td>
</tr>
<tr class="row-even"><td><p>F0pXFRef</p></td>
<td><p>VectorDouble</p></td>
<td><p>N</p></td>
<td><p>Initial slope of longitudinal force at reference force</p></td>
</tr>
<tr class="row-odd"><td><p>F0pX2FRef</p></td>
<td><p>VectorDouble</p></td>
<td><p>N</p></td>
<td><p>Initial slope of longitudinal force at  double reference force</p></td>
</tr>
<tr class="row-even"><td><p>MuTireMaxYFRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Normalized scaling factor for maximum lateral force at reference vertical force</p></td>
</tr>
<tr class="row-odd"><td><p>MuTireMaxY2FRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Normalized scaling factor for maximum lateral force at double reference vertical force</p></td>
</tr>
<tr class="row-even"><td><p>MuTireSlideYFRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Normalized scaling factor for sliding lateral force at reference vertical force</p></td>
</tr>
<tr class="row-odd"><td><p>MuTireSlideY2FRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Normalized scaling factor for sliding lateral force at double reference vertical force</p></td>
</tr>
<tr class="row-even"><td><p>SlipTireMaxYFRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Lateral slip at maximum lateral force at reference vertical force</p></td>
</tr>
<tr class="row-odd"><td><p>SlipTireMaxY2FRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Lateral slip at maximum lateral force at double reference vertical force</p></td>
</tr>
<tr class="row-even"><td><p>SlipTireSlideYFRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Lateral slip at sliding lateral force at reference vertical force</p></td>
</tr>
<tr class="row-odd"><td><p>SlipTireSlideY2FRef</p></td>
<td><p>VectorDouble</p></td>
<td></td>
<td><p>Lateral slip at sliding lateral force at double reference vertical force</p></td>
</tr>
<tr class="row-even"><td><p>F0pYFRef</p></td>
<td><p>VectorDouble</p></td>
<td><p>N</p></td>
<td><p>Initial slope of lateral force at reference force</p></td>
</tr>
<tr class="row-odd"><td><p>F0pY2FRef</p></td>
<td><p>VectorDouble</p></td>
<td><p>N</p></td>
<td><p>Initial slope of lateral force at  double reference force</p></td>
</tr>
<tr class="row-even"><td><p>FRef</p></td>
<td><p>VectorDouble</p></td>
<td><p>N</p></td>
<td><p>Vertical reference force for the tire parameters</p></td>
</tr>
<tr class="row-odd"><td><p>FRefNormalized</p></td>
<td><p>VectorBool</p></td>
<td></td>
<td><p>Should the reference force be scaled with the static vertical tire force?</p></td>
</tr>
<tr class="row-even"><td><p>Inertia</p></td>
<td><p>VectorDouble</p></td>
<td><p>kgm²</p></td>
<td><p>Inertia of tire</p></td>
</tr>
<tr class="row-odd"><td><p>PneumaticTrail</p></td>
<td><p>VectorDouble</p></td>
<td><p>m</p></td>
<td><p>Pneumatic trail of tire</p></td>
</tr>
</tbody>
</table>
<p>The normalized factors refer to the reference vertical force or to the double reference vertical force
The input variables used by the model are tire drive and braking torques as well as the wheel angles and vertical wheel forces. All data is provided as vectors.
The model determines tire forces in the longitudinal and lateral directions as well as the wheel self aligning torques. The wheel self aligning torque is formed from the product of the tire side force and the pneumatic trail.
A linear interpolation is performed between the values for the reference force and the double reference force. If no degressive tire behavior is desired, the parameters for the double reference force must be set identically to the values for the reference force.</p>
<p>All forces are scaled with the coefficient of friction from the <a class="reference internal" href="../../configs/scenario.html#scenario-vehiclemodels"><span class="std std-ref">VehicleCatalog</span></a> (“FrictionCoefficient”).</p>
<p>All further information about the model can be found in the following sources:</p>
<p><a class="reference external" href="https://www.tmeasy.de/">https://www.tmeasy.de/</a></p>
<p>Rill, Georg. (2013). TMeasy – A Handling Tire Model based on a three-dimensional slip approach.</p>
</section>
<section id="dynamicsmotionmodel">
<span id="components-motionmodel"></span><h3>DynamicsMotionModel<a class="headerlink" href="#dynamicsmotionmodel" title="Link to this heading"></a></h3>
<p>The motion model converts the tire forces (input) into a translational and rotational movement of the vehicle. The air resistance of the vehicle is taken into account. For the dynamic calculation, the center of gravity position is taken from the <a class="reference internal" href="../../configs/scenario.html#scenario-vehiclemodels"><span class="std std-ref">VehicleCatalog</span></a> (“XPositionCOG”,”YPositionCOG”),
which indicates the distance of the center of gravity to the center of the rear axle. If this data is not given, the center of gravity is positioned on half wheelbase. For air resistance, the properties “AirDragCoefficient” &amp; “FrontSurface” from the <a class="reference internal" href="../../configs/scenario.html#scenario-vehiclemodels"><span class="std std-ref">VehicleCatalog</span></a> are used.</p>
<p>For the equations of motion, see relevant vehicle dynamics books such as:</p>
<p>Kücükay, Ferit (2022), “Grundlagen der Fahrzeugtechnik”, page 1067 ff</p>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="spawner.html" class="btn btn-neutral float-left" title="Spawner" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="../../../advanced_topics/20_simulator_advanced.html" class="btn btn-neutral float-right" title="Simulator" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>